Index: trunk/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 5083)
+++ trunk/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 5134)
@@ -1301,4 +1429,181 @@
 	}
 
+	
+	//TODO: Descartar código após atualização do módulo de segurança da SERPRO
+	function extractSignedContents( $data ) 
+    { 
+		$pipes_desc = array( 
+			0 => array('pipe', 'r'), 
+			1 => array('pipe', 'w') 
+	    ); 
+	 
+	    $fp = proc_open( 'openssl smime -verify -noverify -nochain', $pipes_desc, $pipes); 
+	    if (!is_resource($fp)) { 
+			return false; 
+	    } 
+	 
+	    $output = ''; 
+	 
+ 		/* $pipes[0] => writeable handle connected to child stdin 
+ 		$pipes[1] => readable handle connected to child stdout */ 
+ 	    fwrite($pipes[0], $data); 
+ 	    fclose($pipes[0]); 
+ 	 
+ 	    while (!feof($pipes[1])) { 
+			$output .= fgets($pipes[1], 1024); 
+ 	    } 
+ 	    fclose($pipes[1]); 
+ 	    proc_close($fp); 
+ 	 
+ 	    return $output; 
+ 	}
+    ///////////////////////////////////////////////////////////////////////////////////////
+    
+        function builderMsgCalendar($calendar)
+        {
+            $icalService = ServiceLocator::getService('ical');
+
+            $codificao =  mb_detect_encoding($calendar.'x', 'UTF-8, ISO-8859-1');
+            if($codificao == 'UTF-8')
+                $calendar = utf8_decode($calendar);
+
+            if($icalService->setIcal($calendar))
+            {
+                $content = '';
+
+                switch ($icalService->getMethod()) {
+
+                    case 'REPLY':
+                          include_once($_SESSION['rootPath'].'/header.inc.php');
+                          include_once($_SESSION['rootPath'].'/calendar/inc/class.boicalendar.inc.php');
+                          $boicalendar = new boicalendar();
+
+                          $ical = $icalService->getComponent('vevent');
+                          $content.= '<b>'.$this->functions->getLang('Event Calendar').'</b><br /><br />';
+                          $content.= '<span style="font-size: 12" >';
+                          $notExist = false;
+
+                          foreach ($ical['attendee'] as $attendee)
+                          {
+                                if($attendee['params']['PARTSTAT'] == 'ACCEPTED')
+                                {
+                                    if($boicalendar->updateExParticipantState($ical['uid']['value'],$attendee['value'],'ACCEPTED',$attendee['params']['CN']))
+                                    {
+                                        $content.= $this->functions->getLang('User').' ';
+                                        if($attendee['params']['CN'])
+                                            $content.= '<b>'.$attendee['params']['CN'].'</b> ';
+                                        else
+                                            $content.= '<b>'.$attendee['value'].'</b> ';
+
+                                        $content.= $this->functions->getLang('accepted your event');
+                                    }
+                                    else
+                                        $notExist = true;
+                                }
+
+                                if($attendee['params']['PARTSTAT'] == 'TENTATIVE')
+                                {
+                                    if($boicalendar->updateExParticipantState($ical['uid']['value'],$attendee['value'],'TENTATIVE',$attendee['params']['CN']))
+                                    {
+                                        $content.= $this->functions->getLang('User').' ';
+                                        if($attendee['params']['CN'])
+                                            $content.= '<b>'.$attendee['params']['CN'].'</b> ';
+                                        else
+                                            $content.= '<b>'.$attendee['value'].'</b> ';
+
+                                        if($ical['description']['value'])
+                                            $content.= ' <br /> '.str_replace('\n','<br />',nl2br($ical['description']['value']));
+                                        else
+                                            $content.= $this->functions->getLang('provisionally accepted you event');
+                                    }
+                                    else
+                                         $notExist = true;
+                                }
+
+                                if($attendee['params']['PARTSTAT'] == 'DECLINED')
+                                {
+                                    if($boicalendar->updateExParticipantState($ical['uid']['value'],$attendee['value'],'DECLINED',$attendee['params']['CN']))
+                                    {
+                                        $content.= $this->functions->getLang('User').' ';
+                                        if($attendee['params']['CN'])
+                                            $content.= '<b>'.$attendee['params']['CN'].'</b> ';
+                                        else
+                                            $content.= '<b>'.$attendee['value'].'</b> ';
+
+                                        if($ical['description']['value'])
+                                            $content.= ' <br /> '.str_replace('\n','<br />',nl2br($ical['description']['value']));
+                                        else
+                                            $content.= $this->functions->getLang('provisionally decline you event');
+                                    }
+                                    else
+                                        $notExist = true;
+                                }
+                          }
+                          if($notExist)
+                            $content.= '<b><span style="color:red">'.$this->functions->getLang('This event does not exist on its agenda').'.</span></b>';
+                          $content.= '</span><br /><br />';
+
+                        break;
+
+                      case 'CANCEL':
+
+                          $ical = $icalService->getComponent('vevent');
+                          $content.= '<b>'.$this->functions->getLang('Event Calendar').'</b><br /><br />';
+                          $content.= '<span style="font-size: 12" >';
+                          $content.= '<b><span style="color:red">'.$this->functions->getLang('Your event has been canceled').'</span></b>';
+   
+                          if($ical['description']['value'])
+                              $content.= ' <br /> <br /> '.str_replace('\n','<br />',nl2br($ical['description']['value']));
+
+                          $content.= '<br /><b>* '.$this->functions->getLang('To remove the event from your calendar to import the iCal file attached').'.</b>';
+                          $content.= '</span><br /><br />';
+                        break;
+
+                    case 'REQUEST':
+
+                        $ical = $icalService->getComponent('vevent');
+                        if($ical['dtstart']['value']['tz'] == 'Z')
+                        {
+                            $tz = $_SESSION['phpgw_info']['user']['preferences']['common']['tz_offset'];
+                            $ical['dtstart']['value']['hour'] += $tz;
+                            $ical['dtend']['value']['hour'] += $tz;
+                        }
+                        
+                        $content.= '<b>'.$this->functions->getLang('Event Calendar').'</b><br />'.
+                                   ' <br /> <b>'.$this->functions->getLang('Title').': </b>'.$ical['summary']['value'].
+                                   ' <br /> <b>'.$this->functions->getLang('Location').': </b>'.$ical['location']['value'].
+                                   ' <br /> <b>'.$this->functions->getLang('Details').': </b>'. str_replace('\n','<br />',nl2br($ical['description']['value']));
+                        $content.= ' <br /> <b>'.$this->functions->getLang('Start') . ':  </b>' . $ical['dtstart']['value']['day'] . "/" . $ical['dtstart']['value']['month']  . "/" . $ical['dtstart']['value']['year']  . " - " . $ical['dtstart']['value']['hour']  . ":" . $ical['dtstart']['value']['min'] ;
+                        $content.= ' <br /> <b>'.$this->functions->getLang('End') . ': </b>' . $ical['dtend']['value']['day'] . "/" . $ical['dtend']['value']['month']  . "/" . $ical['dtend']['value']['year']  . " - " . $ical['dtend']['value']['hour']  . ":" . $ical['dtend']['value']['min'] ;
+
+                        if($ical['organizer']['params']['CN'])
+                             $content.= ' <br /> <b>'.$this->functions->getLang('Organizer').': </b>'.$ical['organizer']['params']['CN'].' -  <a href="MAILTO:'.$ical['organizer']['value'].'">'.$ical['organizer']['value'].'</a></li>' ;
+                        else
+                             $content.= ' <br /> <b>'.$this->functions->getLang('Organizer').': </b> <a href="MAILTO:'.$ical['organizer']['value'].'">'.$ical['organizer']['value'].'</a>' ;
+
+                        if($ical['attendee'])
+                        {
+                            $att = ' <br /> <b>'.$this->functions->getLang('Participants').': </b>';
+                            $att .= '<ul> ';
+                            foreach ($ical['attendee'] as $attendee)
+                            {
+                                if($attendee['params']['CN'])
+                                    $att .= '<li>'.$attendee['params']['CN'].' -  <a href="MAILTO:'.$attendee['value'].'">'.$attendee['value'].'</a></li>'  ;
+                                else
+                                    $att .= '<li><a href="MAILTO:'.$attendee['value'].'">'.$attendee['value'].'</a></li>'  ;
+                            }
+                            $att .= '</ul> <br />'  ;
+                        }
+                        $content.= $att;
+
+                        break;
+                    default:
+                        break;
+                }
+      
+            }
+            return $content;
+        }
+        
 	function htmlfilter($body)
 	{
@@ -1454,8 +1759,11 @@
                 $image['cid'] = eregi_replace("<", "", $image['cid']);
                 $image['cid'] = eregi_replace(">", "", $image['cid']);
+				//if is Draft Ticket #1256
+				$image['cid'] = str_replace("@localhost", "@prognus.org", $image['cid']);
 				$body = eregi_replace("<br/>", "", $body);
-                $body = str_replace("src=\"cid:".$image['cid']."\"", " src=\"./inc/show_embedded_attach.php?msg_folder=$msg_folder&msg_num=$msgno&msg_part=".$image['pid']."\" ", $body);
-                $body = str_replace("src='cid:".$image['cid']."'", " src=\"./inc/show_embedded_attach.php?msg_folder=$msg_folder&msg_num=$msgno&msg_part=".$image['pid']."\" ", $body);
-                $body = str_replace("src=cid:".$image['cid'], " src=\"./inc/show_embedded_attach.php?msg_folder=$msg_folder&msg_num=$msgno&msg_part=".$image['pid']."\" ", $body);   
+				
+                $body = str_replace("src=\"cid:".$image['cid']."\"", " src=\"./inc/get_archive.php?msgFolder=$msg_folder&msgNumber=$msgno&indexPart=".$image['pid']."\" ", $body);
+                $body = str_replace("src='cid:".$image['cid']."'", " src=\"./inc/get_archive.php?msgFolder=$msg_folder&msgNumber=$msgno&indexPart=".$image['pid']."\"", $body);
+                $body = str_replace("src=cid:".$image['cid'], " src=\"./inc/get_archive.php?msgFolder=$msg_folder&msgNumber=$msgno&indexPart=".$image['pid']."\"", $body); 
 			}
 		return $body;
@@ -1474,7 +1782,13 @@
                 $body = @mb_eregi_replace("POSITION: ABSOLUTE;","",$body);
 
+		//Remove Comentario Expresso 
+				$findExpCom[] = '<!-- TAG <'; 
+				$findExpCom[] = '> Removed by ExpressoMail -->'; 
+				$body = str_replace($findExpCom, '', $body); 
+		///--------------------------------// 
+
 		// tags to be removed doe to security reasons
 		$tag_list = Array(
-			'head','blink','object','frame','iframe',
+			'blink','object','frame','iframe',
 			'layer','ilayer','plaintext','script',
 			'applet','embed','frameset','xml','xmp'
@@ -1482,6 +1796,9 @@
 
 		foreach($tag_list as $index => $tag) {
-			$body = @mb_eregi_replace("<$tag\\b[^>]*>(.*?)</$tag>", "<!-- TAG <$tag> Removed by ExpressoMail -->", $body); 
-			}
+			$body = @mb_eregi_replace("<$tag\\b[^>]*>(.*?)</$tag>", '', $body); 
+			}
+		
+		$body = @mb_eregi_replace("<meta[^>]*>", '', $body);
+		$body = @mb_eregi_replace("<base[^>]*>", '', $body); 
 		
 		//try to wrap CSS code instead of remove STYLE tags
@@ -1492,4 +1809,5 @@
 		$regs_found = array(); 
 		$tags_found = @mb_eregi("<style\b[^>]*>(.*?)</style>", $body, $regs_found);
+		$wrapper_class = 'ExpressoCssWrapper'.time();
 		
 		foreach ($regs_found as $block_found) { 
@@ -1504,4 +1822,5 @@
 			
 			$prefix = ".$wrapper_class "; 
+            if( isset($css->css[41]) && count($css->css[41] > 0))
 			foreach ($css->css[41] as $key => $value) {
 						//explode multiple selectors per block 
@@ -1541,35 +1860,18 @@
 	    //--------------------------------------------------------------------------------------------// 	
 
-		//$body = $this->replace_links($body);
-
 		//Remoção de tags <span></span> para correção de erro no firefox
-//               if($_SESSION['phpgw_session']['phpgw_app_sessions']['phpgwapi']['browser_agent']['content'] != 'IE'){
-//                   $body = mb_eregi_replace("<span><span>","",$body);
-//                   $body = mb_eregi_replace("</span></span>","",$body);
-//               }
-
-                $body = mb_ereg_replace("(<p[^>]*)(text-indent:[^>;]*-[^>;]*;)([^>]*>)","\\1\\3",$body);
-                $body = mb_ereg_replace("(<p[^>]*)(margin-right:[^>;]*-[^>;]*;)([^>]*>)","\\1\\3",$body);
-                $body = mb_ereg_replace("(<p[^>]*)(margin-left:[^>;]*-[^>;]*;)([^>]*>)","\\1\\3",$body);
-//Correção para compatibilização com Outlook, ao visualizar a mensagem 
+		//Comentado pois estes replaces geram erros no html da msg, não se pode garantir que o os </span></span> sejam realmente os fechamentos dos <span><span>.
+		//Caso realmente haja a nescessidade de remover estes spans deve ser repensado a forma de como faze-lo.
+		//		$body = mb_eregi_replace("<span><span>","",$body);
+		//		$body = mb_eregi_replace("</span></span>","",$body);
+
+		//Correção para compatibilização com Outlook, ao visualizar a mensagem
 		$body = mb_ereg_replace('<!--\[','<!-- [',$body); 
 		$body = mb_ereg_replace('&lt;!\[endif\]--&gt;', '<![endif]-->', $body);
-                $body = mb_ereg_replace('<!\[endif\]-->', '<!--[endif]--->', $body);
-		$body = str_replace("\x00", '', $body);
 		
 		return  "<div class=\"$wrapper_class\"><span>".$body.'</span></div>';
-	}
-
-
-
+
+	}
 	
-	/**
-	* Substitui os links do callback
-	*
-	* @license    http://www.gnu.org/copyleft/gpl.html GPL
-	* @author     Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-	* @sponsor    Caixa Econômica Federal
-	* @param      $matches
-	*/
 	function replace_links_callback($matches)  
 	{
@@ -1595,8 +1897,4 @@
 		$replacement = '<a href="://$4$5" target="_blank">$4$5</a>'; 
  	    $body = preg_replace_callback($pattern,array( &$this, 'replace_links_callback'), $body);
-		// E-mail address in the text should create a new e-mail on ExpressoMail
-		$pattern = '/( |<|&lt;|>)([A-Za-z0-9\.~?\/_=#\-]*@[A-Za-z0-9\.~?\/_=#\-]*)( |>|&gt;|<)/im'; 
-		$replacement = '$1<a href="mailto:$2">$2</a>$3';
-		$body = preg_replace( $pattern, $replacement, $body );
 
 	}
@@ -1716,20 +2014,13 @@
 	{
 
-		$thumbs_array = array();
-		$i = 0;
-
-            foreach ($images as $x => $image)
-    	{
-                 if($x && $x == 'names')
-                    continue;
-                 
-                 $img = "<img id='".$msg_folder.";;".$msg_number.";;".$i.";;".$image['pid'].";;".$image['encoding']."' title='".$this->functions->getLang("Click here do view (+)")."'src=./inc/show_thumbs.php?&msg_num=".$msg_number."&msg_folder=".$msg_folder."&msg_part=".$image['pid']." />";
-                 $href = "./inc/show_img.php?msg_num=".$msg_number."&msg_folder=".$msg_folder."&msg_part=".$image['pid'];
-				 $anchor = "<a class=\"expressomail-thumbs-link\" onMouseDown='save_image(event,this,\"".$image['type']."\")' href=\"".$href."\" onclick=\"window.open('".$href."','mywindow','width=700,height=600,scrollbars=yes');return false;\">". $img ."</a>";
-                 $thumbs_array[] = $anchor; 
-    			$i++;
+		if (!count($images)) return '';
                
+		foreach ($images as $key => $value) { 
+			$images[$key]['width']  = 160; 
+			$images[$key]['height'] = 120; 
+			$images[$key]['url']    = "inc/get_archive.php?msgFolder=".$msg_folder."&msgNumber=".$msg_number."&indexPart=".$image['pid']."&image=true"; 
     		}
-    	return $thumbs_array;
+
+		return json_encode($images); 
 	}
 
@@ -1755,9 +2046,11 @@
 		$folder =  mb_convert_encoding($folder, "UTF7-IMAP","ISO-8859-1");
 		$msgs_number = explode(",",$params['msgs_number']);
+		if(array_key_exists('border_ID' ,$params))
 		$border_ID = $params['border_ID'];
-
+		else
+			$border_ID = '';
 		$return = array();
 
-		if ($params['get_previous_msg']){
+		if (array_key_exists('get_previous_msg' , $params) &&  $params['get_previous_msg']){
 			$return['previous_msg'] = $this->get_info_previous_msg($params);
 			// Fix problem in unserialize function JS.
@@ -1786,4 +2079,6 @@
 	{
 
+		$return = array();
+		$return['new_msgs'] = 0;
 		$folder = $params['folder'];
 		$msg_range_begin = $params['msg_range_begin'];
@@ -1799,17 +2094,36 @@
 			return array();
 
+		$return['new_msgs'] = imap_num_recent($this->mbox);
 		$num_msgs = (count($msgs_in_the_server) - imap_num_recent($this->mbox));
+
 		$msgs_in_the_client = explode(",", $msgs_existent);
 
 		$msg_to_insert  = array_diff($msgs_in_the_server, $msgs_in_the_client);
+
+		if(count($msg_to_insert) > 0 && $return['new_msgs'] == 0 && $msgs_in_the_client[0] != ""){
+			$aux = 0;
+			while(array_key_exists($aux, $msg_to_insert)){
+				if($msg_to_insert[$aux] > $msgs_in_the_client[0]){
+					$return['new_msgs'] += 1;
+				}
+				$aux++;
+			}
+		}else if(count($msg_to_insert) > 0 && $msgs_in_the_server && $msgs_in_the_client[0] != "" && $return['new_msgs'] == 0){
+			$aux = 0;
+			while(array_key_exists($aux, $msg_to_insert)){
+				if($msg_to_insert[$aux] == $msgs_in_the_server[$aux]){
+					$return['new_msgs'] += 1;
+				}
+				$aux++;
+			}
+		}else if($num_msgs < $msg_range_end && $return['new_msgs'] == 0 && count($msg_to_insert) > 0){
+			$return['tot_msgs'] = $num_msgs;
+		}
+		
 		$msg_to_delete = array_diff($msgs_in_the_client, $msgs_in_the_server);
-
 		$msgs_to_exec = array();
 		foreach($msg_to_insert as $msg_number)
 			$msgs_to_exec[] = $msg_number;
 		//sort($msgs_to_exec);
-
-		$return = array();
-                $return['new_msgs'] = imap_num_recent($this->mbox);
 		$i = 0;
 		foreach($msgs_to_exec as $msg_number)
@@ -1864,5 +2178,5 @@
 			$return[$i]['from']['email'] = $from[0]->mailbox . "@" . $from[0]->host;
 			//$return[$i]['from']['full'] ='"' . $return[$i]['from']['name'] . '" ' . '<' . $return[$i]['from']['email'] . '>';
-			if(!$return[$i]['from']['name'])
+			if(!$return[$i]['from']['name'] || trim($return[$i]['from']['name']) === '')
 				$return[$i]['from']['name'] = $return[$i]['from']['email'];
 
@@ -1873,18 +2187,33 @@
 			$to = $header->to;
 			$return[$i]['to'] = array();
+			if(isset($to[0]->personal))
 			$tmp = imap_mime_header_decode($to[0]->personal);
+			if(trim($return[$i]['to']['name']) === '')
+				$return[$i]['to']['name'] = $to[0]->mailbox . "@" . $to[0]->host;
+			else
 			$return[$i]['to']['name'] = $tmp[0]->text;
 			$return[$i]['to']['email'] = $to[0]->mailbox . "@" . $to[0]->host;
 			$return[$i]['to']['full'] ='"' . $return[$i]['to']['name'] . '" ' . '<' . $return[$i]['to']['email'] . '>';
+			if(isset($header->cc))
 			$cc = $header->cc;
-			if ( ($cc) && (!$return[$i]['to']['name']) ){
+
+			if ( isset($cc) && (!$return[$i]['to']['name'] || $return[$i]['to']['name'] == '@') ){
 				$return[$i]['to']['name'] =  $cc[0]->personal;
 				$return[$i]['to']['email'] = $cc[0]->mailbox . "@" . $cc[0]->host;
 			}
-			$return[$i]['subject'] = $this->decode_string($header->fetchsubject);
-
+                        $return[$i]['subject'] = ( isset( $header->fetchsubject ) ) ? $this->decode_string($header->fetchsubject) : '';
+                        if($return[$i]['subject'] == "" || $return[$i]['subject'] == '' || $return[$i]['subject'] == null ){
+				$return[$i]['subject'] = $this->functions->getLang("(no subject)   ");
+			}
 			$return[$i]['Size'] = $header->Size;
 			$return[$i]['reply_toaddress'] = $header->reply_toaddress;
 
+			if($return[$i]['to']['email'] == '@' || $return[$i]['to']['email'] =='undisclosed-recipients@' || $return[$i]['to']['name'] =='undisclosed-recipients@'
+				|| $return[$i]['to']['name'] == null){
+				$return[$i]['to']['email'] = $return[$i]['from']['email'];
+				$return[$i]['to']['name'] = $return[$i]['from']['name'];
+				$return[$i]['to']['full'] = $return[$i]['reply_toaddress'];
+			}
+			
 			$return[$i]['attachment'] = array();
 			if (!isset($imap_attachment))
@@ -1949,14 +2278,17 @@
 	{
 		$mbox_stream = $this->open_mbox();
-		if($params && $params['onload'] && $_SESSION['phpgw_info']['expressomail']['server']['certificado']){
+		if($params &&  array_key_exists('onload', $params)   &&  $params['onload'] && $_SESSION['phpgw_info']['expressomail']['server']['certificado']){
 			$this->delete_mailbox(array("del_past" => "INBOX".$this->imap_delimiter."decifradas"));
 		}
 
 		$inbox = 'INBOX';
+		$drafts = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultDraftsFolder'];
+		$sent = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSentFolder'];
+		$spam = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSpamFolder'];
 		$trash = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultTrashFolder'];
-		$drafts = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultDraftsFolder'];
-		$spam = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSpamFolder'];
-		$sent = $inbox . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSentFolder'];
+		if(array_key_exists('uid2cn', $_SESSION['phpgw_info']['user']['preferences']['expressoMail'] ))
 		$uid2cn = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['uid2cn']; 
+		else
+			$uid2cn = false;
 		// Free others requests 
 		session_write_close(); 
@@ -1964,5 +2296,5 @@
 		$serverString = "{".$this->imap_server.":".$this->imap_port.$this->imap_options."}"; 
 		
-		if ( $params && $params['noSharedFolders'] )
+		if ( $params && isset($params['noSharedFolders']) )
 			$folders_list = array_merge(imap_getmailboxes($mbox_stream, $serverString, 'INBOX' ), imap_getmailboxes($mbox_stream, $serverString, 'INBOX/*' ) );
 		else
@@ -1973,5 +2305,9 @@
 		$tmp = array(); 
 		$resultMine = array(); 
+		$resultSharedMine = array(); 
 		$resultDefault = array(); 
+		$resultSharedDefault = array(); 
+		$aux = "";
+		$qtd = -1 ;
 
 		if (is_array($folders_list)) {
@@ -1994,9 +2330,6 @@
                             if( $folderUser != "INBOX" && $folderUser != "" )
                             {
-                               $Permission = imap_getacl( $mbox_stream, $folderUser );
+                               $Permission = @imap_getacl( $mbox_stream, $folderUser );
                             }
-
-                            if( $Permission )
-                            {
                                 $tmp_folder_id[1] = mb_convert_encoding( $tmp_folder_id[1], "ISO-8859-1", "UTF7-IMAP" );
 
@@ -2005,5 +2338,8 @@
 					continue;
 				}
+				
+				if(isset($status->unseen))
 				$result[$i]['folder_unseen'] = $status->unseen;
+				
 				$folder_id = $tmp_folder_id[1];
 				$result[$i]['folder_id'] = $folder_id;
@@ -2027,15 +2363,37 @@
 				else
 					$result[$i]['folder_hasChildren'] = 0;
-
+				$user = explode($this->imap_delimiter , $tmp_folder_id[1]);
 				switch ($tmp_folder_id[1]) {
 					case $inbox:
+					case $drafts:
 					case $sent:
-					case $drafts:
 					case $spam:
 					case $trash:
 						$resultDefault[]=$result[$i];
 						break;
+					case "user". $this->imap_delimiter . $user[1]:
+					case "user". $this->imap_delimiter . $user[1] . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultDraftsFolder']:
+					case "user". $this->imap_delimiter . $user[1] . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSentFolder']:
+					case "user". $this->imap_delimiter . $user[1] . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSpamFolder']:
+					case "user". $this->imap_delimiter . $user[1] . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultTrashFolder']:
+						if($aux != $user[1]){
+							$aux = $user[1];
+							$qtd += 1;
+						}
+						if( isset($resultSharedDefault[$qtd]) && !is_array($resultSharedDefault[$qtd]))
+							$resultSharedDefault[$qtd] = array();
+						$resultSharedDefault[$qtd][]=$result[$i];
+						break;	
 					default:
+						if($user[0] == $inbox)
 						$resultMine[]=$result[$i];
+						else{
+							if($aux != $user[1]){
+								$aux = $user[1];
+								$qtd += 1;
+							}
+							if(!is_array($resultSharedDefault[$qtd]))
+								$resultSharedMine[$qtd] = array();
+							$resultSharedMine[$qtd][]=$result[$i];
 				}
 
@@ -2045,8 +2403,8 @@
 		}
 
-		if ( $params && !$params['noQuotaInfo'] ) {
+		if ( $params && !array_key_exists('noQuotaInfo',$params) ) {
 			//Get quota info of current folder
 			$current_folder = "INBOX";
-			if($params && $params['folder'])
+			if($params && isset($params['folder']))
 				$current_folder = $params['folder'];
 
@@ -2078,8 +2436,8 @@
 					$resultDefault2[0] = $resultDefault[$key];
 					break;
-				case $sent: 
+				case $drafts: 
 					$resultDefault2[1] = $resultDefault[$key];
 					break;
-				case $drafts: 
+				case $sent: 
 					$resultDefault2[2] = $resultDefault[$key];
 					break;
@@ -2093,13 +2451,45 @@
 		}
 		
-		if ( $params && $params['folderType'] && $params['folderType'] == 'default' )
+		$shareds = array();
+		if(!empty($resultSharedDefault))
+		for($i = 0; $i <= $qtd; $i++){			
+			foreach ($resultSharedDefault[$i] as $key => $folder_id)
+			{
+				$user = explode($this->imap_delimiter , $resultSharedDefault[$i][$key]['folder_id']);
+
+				switch ($resultSharedDefault[$i][$key]['folder_id']) {
+					case "user". $this->imap_delimiter . $user[1]: 
+						$resultSharedDefault2[0] = $resultSharedDefault[$i][$key];
+						break;
+					case "user". $this->imap_delimiter . $user[1]. $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultDraftsFolder']:  
+						$resultSharedDefault2[1] = $resultSharedDefault[$i][$key];
+						break;	
+					case "user". $this->imap_delimiter . $user[1]. $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSentFolder']:  
+						$resultSharedDefault2[2] = $resultSharedDefault[$i][$key];
+						break;
+					case "user". $this->imap_delimiter . $user[1]. $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSpamFolder']:  
+						$resultSharedDefault2[3] = $resultSharedDefault[$i][$key];
+						break;
+					case "user". $this->imap_delimiter . $user[1] . $this->imap_delimiter . $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultTrashFolder']:
+						$resultSharedDefault2[4] = $resultSharedDefault[$i][$key];
+						break;
+				}
+			}
+			if($resultDefault2 != null)
+				$shareds = array_merge($shareds, $resultSharedDefault2);
+			if(isset($resultSharedMine[$i]) && $resultSharedMine[$i] != null)
+				$shareds = array_merge($shareds, $resultSharedMine[$i]);
+			$resultSharedDefault2 = array();
+		}
+		if ( $params && isset($params['folderType']) && $params['folderType'] == 'default' )
 			return array_merge($resultDefault2, $arr_quota_info);
 
-		if ( $params && $params['folderType'] && $params['folderType'] == 'personal' )
+		if ( $params && array_key_exists('folderType', $params) && $params['folderType'] == 'personal' )
 			return array_merge($result2, $arr_quota_info);
 
 		// Merge default folders and personal
 		$result2 = array_merge($resultDefault2, $result2);
-		
+		if(!empty($shareds))
+			$result2 = array_merge($result2, $shareds);
 		return array_merge($result2, $arr_quota_info);
 	}
@@ -2214,9 +2604,12 @@
 	function send_mail($params)
 	{
-		include_once("class.phpmailer.php");
-		$mail = new PHPMailer();
+		require_once $_SESSION['rootPath'] . '/API/class.servicelocator.php';
+		$mailService = ServiceLocator::getService('mail');
+
 		include_once("class.db_functions.inc.php");
 		$db = new db_functions();
 		$fromaddress = $params['input_from'] ? explode(';',$params['input_from']) : "";
+		$message_attachments_contents = (isset($params['message_attachments_content'])) ? $params['message_attachments_content'] : false; 
+		
 		##
 		# @AUTHOR Rodrigo Souza dos Santos
@@ -2238,4 +2631,14 @@
 		$ccaddress = implode(',',$db->getAddrs(explode(',',$params['input_cc'])));
 		$ccoaddress = implode(',',$db->getAddrs(explode(',',$params['input_cco'])));
+
+		$toaddress  = preg_replace('/<\s+/', '<', $toaddress);			
+		$toaddress  = preg_replace('/\s+>/', '>', $toaddress);
+			
+		$ccaddress  = preg_replace('/<\s+/', '<', $ccaddress);
+		$ccaddress  = preg_replace('/\s+>/', '>', $ccaddress);
+		
+		$ccoaddress = preg_replace('/<\s+/', '<', $ccoaddress);
+		$ccoaddress = preg_replace('/\s+>/', '>', $ccoaddress);
+		
 		$replytoaddress = $params['input_replyto'];
 		$subject = $params['input_subject'];
